<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<div class="search">
  <div class="search--bar">
    <span class="search--bar--text">{{"settings.departments.search" | translate}}</span>
    <app-searchbar
      (appSearch)="setFilterParameter('q', $event)"
      [appPlaceholder]="'settings.departments.placeholderSearch' | translate"
      [appSearchText]="appValue?.q"
      class="search--input">
    </app-searchbar>
  </div>

  <div class="filters">

    <button (click)="null"
            class="openk-button openk-button-rounded"
            type="button">
      <mat-icon>filter_list</mat-icon>
    </button>

    <div class="filters--row">
      <div *ngIf="(userRoleOptions$ | async) != null" class="filter-group filter-group---stacked">
        <button
          (click)="toggleFilterParameter('role', roleSelect.appValue)"
          [class.openk-info]="appValue?.role != null"
          class="openk-button openk-chip filters--btn filters--btn---margin">
          {{"settings.users.table.role" | translate}}
        </button>
        <div class="filters--row-select-width">
          <app-select #roleSelect
                      (appValueChange)="setFilterParameter('role', $event)"
                      [appOptions]="userRoleOptions$ | async"
                      [appValue]="(userRoleOptions$ | async)[0].value"
                      class="openk-info filters--select--input-width">
          </app-select>
        </div>

      </div>

      <div *ngIf="(appDepartmentGroups | objKeysToArray).length > 0" class="filter-group filter-group---stacked">
        <div class="filters--block">
          <div class="filter--block--entry">

            <button
              (click)="toggleFilterParameter('departmentGroupName', departmentGroupSelect.appValue)"
              [class.openk-info]="appValue?.departmentGroupName != null"
              class="openk-button openk-chip filters--btn filters--btn---margin">
              {{"settings.users.departmentGroup" | translate}}
            </button>
            <div class="filters--row-select-width">
              <app-select
                #departmentGroupSelect
                (appValueChange)="setFilterParameter('departmentGroupName', $event, true)"
                [appOptions]="appDepartmentGroups | objKeysToArray | arrayToSelectOptions"
                [appValue]="(appDepartmentGroups | objKeysToArray)[0]"
                class="openk-info filters--select--input-width">
              </app-select>
            </div>

          </div>
          <div class="filter--block--entry">
            <button
              (click)="toggleFilterParameter('departmentName', departmentNameSelect.appValue)"
              [class.openk-info]="appValue?.departmentName != null"
              class="openk-button openk-chip filters--btn filters--btn---margin">
              {{"settings.users.department" | translate}}
            </button>
            <div class="filters--row-select-width">
              <app-select #departmentNameSelect
                          (appValueChange)="setFilterParameter('departmentName', $event)"
                          [appDisabled]="!(appDepartmentGroups[departmentGroupSelect.appValue]?.length > 0)"
                          [appOptions]="appDepartmentGroups[departmentGroupSelect.appValue] | arrayToSelectOptions"
                          [appValue]="appDepartmentGroups[departmentGroupSelect.appValue] == null ? null : appDepartmentGroups[departmentGroupSelect.appValue][0]"
                          class="openk-info filters--select--input-width">
              </app-select>
            </div>

          </div>
        </div>
      </div>

      <div *ngIf="(userStateOptions$ | async) != null" class="filter-group filter-group---stacked">
        <button
          (click)="toggleFilterParameter('state', userSelect.appValue)"
          [class.openk-info]="appValue?.state != null"
          class="openk-button openk-chip filters--btn filters--btn---margin">
          {{"settings.users.user" | translate}}
        </button>
        <div class="filters--row-select-width-small">
          <app-select #userSelect
                      (appValueChange)="setFilterParameter('state', $event)"
                      [appOptions]="userStateOptions$ | async"
                      [appValue]="(userStateOptions$ | async)[0].value"
                      class="openk-info filters--select--input-width">
          </app-select>
        </div>

      </div>
    </div>

  </div>
</div>
